import java.util.ArrayList;
import java.util.Vector;
import java.util.LinkedList;
import java.util.Iterator;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.io.*;
import fi.jyu.mit.ohj2.*;

/**
 * Esimerkki Javan algoritmien kytst Java 1.5:n geneerisyyden
 * ja "autoboxin" avulla.  Kytss mys uusi for-silmukka.
 * @author Vesa Lappalainen
 * @version 1.0, 05.03.2002
 * @version 1.1, 01.03.2005
 */

public class AlgoritmiMalliGen {

  /**
   * Luokka joka vertailee kahta kokonaislukuoliota ja
   * palauttaa niiden jrjestyksen niin, ett lajittelu menee
   * laskevaan jrjestykseen.
   */
  public static class LaskevaInt implements Comparator<Integer> {
    public int compare(Integer o1, Integer o2) {
      return o2 - o1;
    }
  }

  public static void tulosta(OutputStream os,  Collection<Integer> luvut) {
    PrintStream out = Tiedosto.getPrintStream(os);
    for (Integer i : luvut ) {
      int luku = i;
      out.print(luku + " ");
    }
    out.println();
  }


  public static void main(String[] args) {
    ArrayList<Integer> luvut = new ArrayList<Integer>();
    try {
      luvut.add(0);  luvut.add(2);
      luvut.add(99); luvut.add(7);
      luvut.add(22); luvut.add(71);
    } catch ( Exception e ) {
      System.out.println("Virhe: " + e.getMessage());
    }
    System.out.println(luvut);                          // [0, 2, 99, 7, 22, 71]

    Collections.sort(luvut);
    tulosta(System.out,luvut);                          // 0 2 7 22 71 99
    Collections.sort(luvut,new LaskevaInt());
    tulosta(System.out,luvut);                          // 99 71 22 7 2 0
    Collections.shuffle(luvut);
    tulosta(System.out,luvut);                          // 99 2 7 71 0 22
    Collections.sort(luvut,Collections.reverseOrder());
    tulosta(System.out,luvut);                          // 99 71 22 7 2 0
    Collections.reverse(luvut);
    tulosta(System.out,luvut);                          // 0 2 7 22 71 99

    int suurin = Collections.max(luvut);
    System.out.println("Suurin = " + suurin);           // Suurin = 99
    int pienin = Collections.min(luvut);
    System.out.println("Pienin = " + pienin);           // Pienin = 0
    pienin = Collections.max(luvut,new LaskevaInt());
    System.out.println("Pienin = " + pienin);           // Pienin = 0

    List<Integer> luvut2 = new LinkedList();
    luvut2.addAll(0,luvut);
    // luvut2.add("Kissa"); // ei mahdollista jos tyyppi ilmoitettu listalle
    tulosta(System.out,luvut2);                         // 0 2 7 22 71 99
    luvut2 = luvut.subList(2,5);
    tulosta(System.out,luvut2);                         // 7 22 71

  }
}
