/**
 * Esimerkki linkitetytst listasta
 * @author Vesa Lappalainen
 * @version 1.0, 16.03.2002
 */

public class LinLista {

  /**
   * Linkitetyn listan yksi alkio.  Sislt datan ja viitteen seuraavaan.
   */
  static public class Alkio {
    private int i;
    private Alkio seuraava;
    public Alkio(int i) { this.i = i; seuraava = null; }
    public int getI() { return i; }
  }

  private Alkio eka;
  private Alkio viimeinen;

  public LinLista() { eka = null; viimeinen = null; }
  public LinLista(int koko) { this(); }

  public void lisaa(int i) {
    Alkio uusi = new Alkio(i);
    if ( eka != null ) viimeinen.seuraava = uusi;
    else eka = uusi;
    viimeinen = uusi;
  }

  public String toString() {
    StringBuffer s = new StringBuffer("");
    for (Alkio i=eka; i!=null; i = i.seuraava )
      s.append(" " + i.getI());
    return s.toString();
  }

  public static void main(String[] args) {
    LinLista luvut = new LinLista();
    try {
      luvut.lisaa(0); luvut.lisaa(2);
      luvut.lisaa(99);
    } catch ( Exception e ) {
      System.out.println("Virhe: " + e.getMessage());
    }
    System.out.println(luvut);
  }
}
