/**
 * Esimerkki dynaamisesta taulukosta
 * @author Vesa Lappalainen
 * @version 1.0, 02.03.2002
 */

public class Taulukko {
  public class TaulukkoTaysiException extends Exception {
    TaulukkoTaysiException(String viesti) { super(viesti); }
  }

  int alkiot[];
  int lkm;

  public Taulukko() {
    alkiot = new int[10];
  }

  public Taulukko(int koko) {
    alkiot = new int[koko];
  }

  public void lisaa(int i) throws TaulukkoTaysiException {
    if ( lkm >= alkiot.length ) throw new TaulukkoTaysiException("Tila loppu");
    alkiot[lkm++] = i;
  }

  public String toString() {
    StringBuffer s = new StringBuffer("");
    for (int i=0; i<lkm; i++)
      s.append(" " + alkiot[i]);
    return s.toString();
  }

  public void set(int i, int luku) throws IndexOutOfBoundsException {
    if ( ( i < 0 ) || ( lkm <= i ) ) throw new IndexOutOfBoundsException("i = " + i);
    alkiot[i] = luku;
  }

  public int get(int i) throws IndexOutOfBoundsException {
    if ( ( i < 0 ) || ( lkm <= i ) ) throw new IndexOutOfBoundsException("i = " + i);
    return alkiot[i];
  }

  public static void main(String[] args) {
    Taulukko luvut = new Taulukko();
    try {
      luvut.lisaa(0); luvut.lisaa(2);
      luvut.lisaa(99);
    } catch ( TaulukkoTaysiException e ) {
      System.out.println("Virhe: " + e.getMessage());
    }
    System.out.println(luvut);
    luvut.set(1,4);
    System.out.println(luvut);
    int luku = luvut.get(2);
    System.out.println("Paikassa 2 on " + luku);
    luvut.set(21,4);
  }
}