/**
 * Esimerkki dynaamisesta taulukosta Java 1.5:n geneerisyytt
 * ja "autoboxingia" kytten.
 * @author Vesa Lappalainen
 * @version 1.0, 02.03.2002
 * @version 1.1, 01.03.2005
 */

public class TaulukkoGen<TYPE> {
  public static class TaulukkoTaysiException extends Exception {
    TaulukkoTaysiException(String viesti) { super(viesti); }
  }

  private Object alkiot[];
  private int lkm;

  public TaulukkoGen() {
    alkiot = new Object[10];
  }

  public TaulukkoGen(int koko) {
    alkiot = new Object[koko];
  }

  public void lisaa(TYPE i) throws TaulukkoTaysiException {
    if ( lkm >= alkiot.length ) throw new TaulukkoTaysiException("Tila loppu");
    alkiot[lkm++] = i;
  }

  public String toString() {
    StringBuffer s = new StringBuffer("");
    for (int i=0; i<lkm; i++)
      s.append(" " + alkiot[i]);
    return s.toString();
  }

  public void set(int i, TYPE luku) throws IndexOutOfBoundsException {
    if ( ( i < 0 ) || ( lkm <= i ) ) throw new IndexOutOfBoundsException("i = " + i);
    alkiot[i] = luku;
  }

  public TYPE get(int i) throws IndexOutOfBoundsException {
    if ( ( i < 0 ) || ( lkm <= i ) ) throw new IndexOutOfBoundsException("i = " + i);
    return (TYPE)alkiot[i];
  }

  public static void main(String[] args) {
    TaulukkoGen<Integer> luvut = new TaulukkoGen<Integer>();
    try {
      luvut.lisaa(0); luvut.lisaa(2);
      luvut.lisaa(99);  // Tekee oikeasti luvut.lisaa(new Integer(99));
    } catch ( TaulukkoTaysiException e ) {
      System.out.println("Virhe: " + e.getMessage());
    }
    System.out.println(luvut);
    luvut.set(1,4);
    System.out.println(luvut);
    int luku = luvut.get(2);  // oik: luku = (Integer)(luvut.get(2)).intValue();
    System.out.println("Paikassa 2 on " + luku);
    try {
      luvut.set(21, 4);
    }
    catch (IndexOutOfBoundsException e) {
      System.out.println("Virhe: " + e.getMessage());
    }
  }
}
