import java.util.*;
import java.io.*;
import fi.jyu.mit.ohj2.*;

/**
 * Esimerkki Javan vektorin kytst Java 1.5:n geneerisyyden
 * ja "autoboxin" avulla.  Kytss mys uusi for-silmukka.
 * @author Vesa Lappalainen
 * @version 1.0, 02.03.2002
 * @version 1.1, 01.03.2005
 */

public class VectorMalliGen {

  public static void tulosta(OutputStream os,  Vector luvut) {
    PrintStream out = Tiedosto.getPrintStream(os);
    for (Iterator<Integer> i = luvut.iterator(); i.hasNext(); ) {
      int luku = i.next();
      out.print(luku + " ");
    }
    out.println();
  }

  public static void tulosta2(OutputStream os,  Collection<Integer> luvut) {
    PrintStream out = Tiedosto.getPrintStream(os);
    for (Integer i : luvut ) {
      out.print(i + " ");
    }
    out.println();
  }

  public static void tulosta3(OutputStream os,  Collection<?> luvut) {
    PrintStream out = Tiedosto.getPrintStream(os);
    for (Object i : luvut ) {
      out.print(i + " ");
    }
    out.println();
  }

  public static void tulosta4(OutputStream os,  Collection luvut) {
    PrintStream out = Tiedosto.getPrintStream(os);
    for (Object i : luvut ) {
      out.print(i + " ");
    }
    out.println();
  }

  public static void main(String[] args) {
    Vector<Integer> luvut = new Vector<Integer>(7);
    try {
      luvut.add(0); luvut.add(2);
      luvut.add(99);
    } catch ( Exception e ) {
      System.out.println("Virhe: " + e.getMessage());
    }
    System.out.println(luvut);
    luvut.set(1,4);
    System.out.println(luvut);
    int luku = luvut.get(2);
    System.out.println("Paikassa 2 on " + luku);
    tulosta(System.out,luvut);
    tulosta2(System.out,luvut);
    tulosta3(System.out,luvut);
    tulosta4(System.out,luvut);
    try {
      luvut.set(21, 4);
    }
    catch (IndexOutOfBoundsException e) {
      System.out.println("Virhe: " + e.getMessage());
    }
  }
}
