/**
 * Ohjelmalla testataan 2. asteen polynomin juurien etsimist
 * @author Vesa Lappalainen
 * @version 1.0, 16.02.2003
 */
public class P2_2r {

  public static void testi(double a, double b, double c) {
    Polynomi2r p = new Polynomi2r(a,b,c);
    System.out.print("Polynomi: " + p);
    if ( p.getReaalijuuria() <= 0 ) {
      System.out.println("  Ei yhtn reaalijuuria! ");
      return;
    }
    System.out.print("  juuret: ");
    System.out.print("x1 = " + p.getX1() + " => P(x1) = " + p.f(p.getX1()) );
    System.out.print("  ja  ");
    System.out.print("x2 = " + p.getX2() + " => P(x2) = " + p.f(p.getX2()) );
    System.out.println();
  }

  public static void main(String[] args)  {
    testi(1,2,1);
    testi(2,1,0);
    testi(1,-2,1);
    testi(2,-1,0);
    testi(2,1,1);
    testi(2,0,0);
    testi(0,2,1);
    testi(0,0,1);
  }
}


/**
 * Luokka toisen asteen polynomille ja sen nollakohdille
 * @author Vesa Lappalainen
 * @version 1.0, 16.02.2003
 */
class Polynomi2r {

  private double a,b,c,x1,x2;
  private int reaalijuuria;

  public Polynomi2r(double a, double b, double c) {
    this.a = a; this.b = b; this.c = c;
    reaalijuuria = ratkaise_2_asteen_yhtalo();
  }

  private int ratkaise_2_asteen_yhtalo() {
    double D,SD;
    x1 = x2 = 0;
    if ( a == 0 ) {
      if ( b == 0 ) {
        if ( c == 0 ) return 1;
        return 0;
      }
      x1 = x2 = -c/b;
      return 1;
    }

    D = b*b - 4*a*c;
    if ( D < 0 ) return -1;

    SD  = Math.sqrt(D);
    x1 = (-b-SD)/(2*a);
    x2 = (-b+SD)/(2*a);
    return 2;
  }

  public static double P2(double x, double a, double b, double c) {
    return (a*x*x + b*x + c);
  }

  public double f(double x) { return P2(x,a,b,c); }
  public double getX1() { return x1; }
  public double getX2() { return x2; }
  public int getReaalijuuria() { return reaalijuuria; }

  public String toString() { return a + "x^2 + " + b + "x + " + c; }

}
