/**
 * Sisinen tilanvalvonta aikaan.
 * @author  Vesa Lappalainen
 * @version 1.0, 01.02.2003
 */
public class Aika4 {

  private int h=0, m=0;

  /**
   * Asettaa uuden ajan ja pit huolen ett aika on aina oikeaa muotoa.
   * @param h asetettavat tunnit
   * @param m asetettavat minuutit
   */
  public void aseta(int h,int m) {
    this.h = h; this.m = m; lisaa(0);
  }

  public Aika4() { // Oletusmuodostaja
    aseta(0,0);
  }

  /**
   * Asettaa uuden ajan ja pit huolen ett aika on aina oikeaa muotoa.
   * @param h asetettavat tunnit
   */
  public Aika4(int h) {
    aseta(h,0);
  }

  /**
   * Alustaa ajan
   * @param h tunnit
   * @param m minuutit
   */
  public Aika4(int h,int m) { // Muodostaja
    aseta(h,m);
  }

  /**
   * Tulostaa ajan muodossa 15:05
   */
  public void tulosta() {
    System.out.println("" + h + ":" + (m<10?"0":"")+m);
  }

  /**
   * Lis aikaan valitun minuuttimrn
   * @param lisa_min listtv minuuttimr
   */
  public void lisaa(int lisa_min)  {
    int yht_min = h * 60 + m + lisa_min;
    h = yht_min / 60;
    m = yht_min % 60;
  }

  public static void main(String[] args) {
    Aika4 a1 = new Aika4();
    Aika4 a2 = new Aika4(13);
    Aika4 a3 = new Aika4(14,25);

    a1.tulosta();  a2.tulosta();  a3.tulosta();
    a1.aseta(12,15); a2.aseta(16,-15);
    a1.tulosta(); a2.tulosta();
  }

}

