/**
 * Vaihettu sisinen esitystapa
 * @author  Vesa Lappalainen
 * @version 1.0, 01.02.2003
 */
public class AikaD {

  private int yht_min;

  /**
   * Asettaa uuden ajan ja pit huolen ett aika on aina oikeaa muotoa.
   * @param h asetettavat tunnit
   * @param m asetettavat minuutit
   */
  public void aseta(int h,int m) {
    yht_min = 60*h + m;
  }

  public AikaD() { yht_min = 0; }

  /**
   * Asettaa uuden ajan ja pit huolen ett aika on aina oikeaa muotoa.
   * @param h asetettavat tunnit
   */
  public AikaD(int h) {
    aseta(h,0);
  }

  /**
   * Alustaa ajan
   * @param h tunnit
   * @param m minuutit
   */
  public AikaD(int h,int m) { // Muodostaja
    aseta(h,m);
  }

  /**
   * Tulostaa ajan muodossa 15:05
   * @param lf tulostetaanko rivinvaihto vai ei
   */
  public void tulosta(boolean lf) {
    int m = getM();
    System.out.print("" + getH() + ":" + (m<10?"0":"")+m);
    if ( lf ) System.out.println();
  }

  /**
   * Tulostaa ajan muodossa 15:05 sek aina rivinvaihdon
   */
  public void tulosta() {
    tulosta(true);
  }

  /**
   * Lis aikaan valitun minuuttimrn
   * @param lisa_min listtv minuuttimr
   */
  public void lisaa(int lisa_min)  {
    yht_min += lisa_min;
  }

  public static void lisaa(AikaD aika,int lisa_min) { aika.lisaa(lisa_min);  }

  public int getH() { return yht_min / 60; }
  public int getM() { return yht_min % 60; }


  public static void main(String[] args) {
    AikaD a1 = new AikaD();
    AikaD a2 = new AikaD(13);
    AikaD a3 = new AikaD(14,25);

    a1.tulosta();  a2.tulosta();  a3.tulosta();
    a1.aseta(12,15); a2.aseta(16,-15);
    a1.tulosta(); a2.tulosta();

    lisaa(a1,55); a1.tulosta();

    System.out.println("Tunnit = " + a1.getH());
  }

}

