/**
 * Luokan laajentaminen koostamalla
 * @author  Vesa Lappalainen
 * @version 1.0, 01.02.2003
 */
public class AikaSek7 {

  private Aika5 hm = new Aika5();
  private int s = 0;

  /**
   * Asettaa uuden ajan ja pit huolen ett aika on aina oikeaa muotoa.
   * @param h asetettavat tunnit
   * @param m asetettavat minuutit
   * @param s asetettavat sekunnit
   */
  public void aseta(int h,int m, int s) {
    hm.aseta(h,m); this.s = s; lisaa(0,0);
  }

  public void aseta(int h,int m) { aseta(h,m,0); }
  public void aseta(int h)       { aseta(h,0);   }

  public AikaSek7() { }

  /**
   * Alustaa ajan
   * @param h tunnit
   * @param m minuutit
   * @param s sekunnit
   */
  public AikaSek7(int h,int m, int s) { // Muodostaja
    aseta(h,m,s);
  }

  public AikaSek7(int h,int m) { aseta(h,m,0); }
  public AikaSek7(int h)       { aseta(h,0,0); }

  /**
   * Tulostaa ajan muodossa 15:05
   * @param lf tulostetaanko rivinvaihto vai ei
   */
  public void tulosta(boolean lf) {
    hm.tulosta(false);
    System.out.print(":" + (s<10?"0":"")+s);
    if ( lf ) System.out.println();
  }

  /**
   * Tulostaa ajan muodossa 15:05 sek aina rivinvaihdon
   */
  public void tulosta() {
    tulosta(true);
  }

  /**
   * Lis aikaan valitun minuuttimrn
   * @param lisa_min listtv minuuttimr
   * @param lisa_sek listtv sekunttimr
   */
  public void lisaa(int lisa_min,int lisa_sek)  {
    s += lisa_sek;
    hm.lisaa(lisa_min+s/60);
    s %= 60;
  }

  public void lisaa(int lisa_min)  { lisaa(lisa_min,0); }

  public static void main(String[] args) {
    Aika5 a1 = new Aika5();
    Aika5 a2 = new Aika5(13);
    Aika5 a3 = new Aika5(14,175);

    a1.tulosta();  a2.tulosta();  a3.tulosta();
    a1.aseta(12,15); a2.aseta(16,-15);
    a1.tulosta(); a2.tulosta();

    AikaSek7 a4 = new AikaSek7(14,55,45); a4.tulosta();
    a4.lisaa(3,30); a4.tulosta();

    Object ajat[] = new Object[5];
    ajat[0] = a1; ajat[1] = a2; ajat[2] = a3; ajat[3] = a4;
    ajat[4] = new AikaSek7(23,59,59);

    // Kmpel esimerkki polymorfisesta taulukosta, ei hyv
    for (int i=0; i < ajat.length; i++ ) {
      if ( ajat[i] instanceof Aika5 ) {
        Aika5 aika = (Aika5)ajat[i];  // pakotettu tyypin muunnos
        aika.tulosta(false); System.out.print(" +" + i + " => ");
        aika.lisaa(i); aika.tulosta();
      }
      if ( ajat[i] instanceof AikaSek7 ) {
        AikaSek7 aika = (AikaSek7)ajat[i];  // pakotettu tyypin muunnos
        aika.tulosta(false); System.out.print(" +" + i + " => ");
        aika.lisaa(i); aika.tulosta();
      }
    }

  }

}

