/**
 * Luokan laajentaminen perimll
 * @author  Vesa Lappalainen
 * @version 1.0, 01.02.2003
 */
public class AikaSek8 extends Aika5 {

  private int s = 0;

  /**
   * Asettaa uuden ajan ja pit huolen ett aika on aina oikeaa muotoa.
   * @param h asetettavat tunnit
   * @param m asetettavat minuutit
   * @param s asetettavat sekunnit
   */
  public void aseta(int h,int m, int s) {
    this.s = s; super.aseta(h,m); lisaa(0,0);
  }

  public AikaSek8() { }

  /**
   * Alustaa ajan
   * @param h tunnit
   * @param m minuutit
   * @param s sekunnit
   */
  public AikaSek8(int h,int m, int s) { // Muodostaja
    aseta(h,m,s);
  }

  public AikaSek8(int h,int m) { aseta(h,m,0); }
  public AikaSek8(int h)       { aseta(h,0,0); }

  /**
   * Tulostaa ajan muodossa 15:05
   * @param lf tulostetaanko rivinvaihto vai ei
   */
  public void tulosta(boolean lf) {
    super.tulosta(false);
    System.out.print(":" + (s<10?"0":"")+s);
    if ( lf ) System.out.println();
  }

  /**
   * Lis aikaan valitun minuuttimrn
   * @param lisa_min listtv minuuttimr
   * @param lisa_sek listtv sekunttimr
   */
  public void lisaa(int lisa_min,int lisa_sek)  {
    s += lisa_sek;
    super.lisaa(lisa_min+s/60);
    s %= 60;
  }

  public static void main(String[] args) {
    Aika5 a1 = new Aika5();
    Aika5 a2 = new Aika5(13);
    Aika5 a3 = new Aika5(14,175);

    a1.tulosta();  a2.tulosta();  a3.tulosta();
    a1.aseta(12,15); a2.aseta(16,-15);
    a1.tulosta(); a2.tulosta();

    AikaSek8 a4 = new AikaSek8(14,55,45); a4.tulosta();
    a4.lisaa(3,30); a4.tulosta();
    AikaSek8 a5 = new AikaSek8();         a5.tulosta();
    AikaSek8 a6 = new AikaSek8(12);       a6.tulosta();
    AikaSek8 a7 = new AikaSek8(12,15);    a7.tulosta();

    Aika5 aika = a1;  aika.tulosta();  // Esimerkki polymorfismista
    aika = a4;        aika.tulosta();
    aika.lisaa(20);   aika.tulosta();
  }

}

