/**
 * Luokan laajentaminen perimll, tarkemmmin mietityt muodostajat
 * @author  Vesa Lappalainen
 * @version 1.0, 01.02.2003
 */
public class AikaSekB extends AikaB {

  private int s;

  /**
   * Asettaa uuden ajan ja pit huolen ett aika on aina oikeaa muotoa.
   * @param h asetettavat tunnit
   * @param m asetettavat minuutit
   * @param s asetettavat sekunnit
   */
  public void aseta(int h,int m, int s) {
    this.s = s; super.aseta(h,m); lisaa(0,0);
  }

  /**
   * Alustaa ajan
   * @param h tunnit
   * @param m minuutit
   * @param s sekunnit
   */
  public AikaSekB(int h,int m, int s) { // Muodostaja
    super(h,m); this.s = s; lisaa(0,0);
  }

  public AikaSekB(int h,int m) { super(h,m); s = 0; }
  public AikaSekB(int h)       { super(h);   s = 0; }
  public AikaSekB()            { super();    s = 0; }


  /**
   * Tulostaa ajan muodossa 15:05
   * @param lf tulostetaanko rivinvaihto vai ei
   */
  public void tulosta(boolean lf) {
    super.tulosta(false);
    System.out.print(":" + (s<10?"0":"")+s);
    if ( lf ) System.out.println();
  }

  /**
   * Lis aikaan valitun minuuttimrn
   * @param lisa_min listtv minuuttimr
   * @param lisa_sek listtv sekunttimr
   */
  public void lisaa(int lisa_min,int lisa_sek)  {
    s += lisa_sek;
    super.lisaa(lisa_min+s/60);
    s %= 60;
  }

  public static void main(String[] args) {
    AikaB a1 = new AikaB();
    AikaB a2 = new AikaB(13);
    AikaB a3 = new AikaB(14,175);

    a1.tulosta();  a2.tulosta();  a3.tulosta();
    a1.aseta(12,15); a2.aseta(16,-15);
    a1.tulosta(); a2.tulosta();

    AikaSekB a4 = new AikaSekB(14,55,45); a4.tulosta();
    a4.lisaa(3,30); a4.tulosta();
    AikaSekB a5 = new AikaSekB();         a5.tulosta();
    AikaSekB a6 = new AikaSekB(12);       a6.tulosta();
    AikaSekB a7 = new AikaSekB(12,15);    a7.tulosta();

    AikaB aika = a1;  aika.tulosta();  // Esimerkki polymorfismista
    aika = a4;        aika.tulosta();
    aika.lisaa(20);   aika.tulosta();
    aika = new AikaSekB(1,95,70); aika.tulosta();

    // Esimerkki polymorfisesta taulukosta
    AikaB ajat[] = new AikaB[5];
    ajat[0] = a1; ajat[1] = a2; ajat[2] = a3; ajat[3] = a4;
    ajat[4] = new AikaSekB(23,59,59);

    for (int i=0; i < ajat.length; i++ ) {
      ajat[i].tulosta(false); System.out.print(" +" + i + " => ");
      ajat[i].lisaa(i); ajat[i].tulosta();
    }

  }

}

