/**
 *  Luokka ja ohjelma yksinkertaisessa muodossa.
 *  Katso kehitys: Astia.java ja Astia2.java
 *<br>
 *  Pelill demonstroidaan/harjoitellaan miten voidaan kahdella astialla,
 *  5 l ja 8 l,  muodostaa kaikki mahdolliset tilavuudet 1-13 l.
 *  Peliss on kaksi varsinaista astiaa: a5 ja a8, sek kolmas apuastia
 *  ampari.  Nestett voidaan kerrallaan kaataa yhdest astiasta toiseen
 *  joko siten, ett astian koko sislt tyhjennetn jos se mahtuu
 *  tai astista kaadetaan sen verran ett toinen astia tulee tyteen.
 *
 * @author  Vesa Lappalainen
 * @version 1.0, 09.02.2003
 */
public class Astia1 {
  private double tilavuus;
  private double maara;

  /**
   * Alustaa uuden astian tietyn kokoiseksi ja luonnollisetsi tyhjksi
   * @param tilavuus uuden astian tilavuus
   */
  public Astia1(double tilavuus) { this.tilavuus = tilavuus; this.maara = 0; }

  /**
   * Tytt astian piripintaan asti
   */
  public void tayta() { maara = tilavuus; }

  /**
   * Kaataa tst astiasta (this) toiseen astiaan niin paljon kuin toiseen
   * mahtuu tai tst astiasta on antaa.
   * @param astia astia johon kaadetaan
   */
  public void kaada(Astia1 astia) {
    double siirrettava = astia.tilavuus - astia.maara;
    if ( maara < siirrettava ) siirrettava = maara;
    astia.maara += siirrettava;
    maara -= siirrettava;
  }

  public double getMaara() { return maara; }

  public static void main(String[] args) {
    Astia1 astia5l = new Astia1(5);
    Astia1 astia8l = new Astia1(8);
    Astia1 ampari  = new Astia1(100);

    ampari.tayta();

    ampari.kaada(astia8l);
    astia8l.kaada(astia5l);

    System.out.println("8 litran astiassa on " + astia8l.getMaara() +
                       " litraa nestett");
  }

}

