import java.io.*;
import fi.jyu.mit.ohj2.*;
import java.util.StringTokenizer;


/**
 * Luokka sanojen esiintymismrien laskemiseksi.
 * @author Vesa Lappalainen
 * @version 1.0, 21.02.2003
 */
public class Sanat {
  private Sana alkiot[] = new Sana[10];
  private int lkm = 0;

  public void lisaa(String s) {
    for (int i=0; i<lkm; i++) {
      if ( alkiot[i].oletko(s) ) {
        alkiot[i].lisaa();
        return;
      }
    }
    if ( lkm >= alkiot.length ) return;
    alkiot[lkm] = new Sana(s);
    alkiot[lkm].lisaa();
    lkm++;
  }

  public void tulosta(OutputStream os) {
    PrintStream out = Tiedosto.getPrintStream(os);
    for (int i=0; i<lkm; i++)
      out.println(alkiot[i]);
  }


  public void kasitteleRivi(String rivi) {
    String sana;
    StringTokenizer st = new StringTokenizer(rivi," ,();.:[]{}+-");
    while ( st.hasMoreTokens() ) {
      sana = st.nextToken();
      lisaa(sana);
    }
  }

  public void lueTiedosto(String tied) throws IOException {
    BufferedReader fi = Tiedosto.avaa_lukemista_varten(tied);
    if ( fi == null ) throw new FileNotFoundException("Ei lydy: " + tied);

    try {
      String rivi;
      while ( ( rivi = fi.readLine() ) != null  ) {
        kasitteleRivi(rivi);
      }
    } finally {
      fi.close();
    }
  }


  public static void main(String[] args)  {
    Sanat sanat = new Sanat();
    sanat.lisaa("kissa");
    sanat.lisaa("kissa");
    sanat.lisaa("koira");
    sanat.tulosta(System.out);
    sanat.kasitteleRivi("kissa, istuu kissa puussa");
    sanat.tulosta(System.out);
  }
}
